// MakeTerrainView.cpp : implementation of the CMakeTerrainView class
//

#include "stdafx.h"
#include "MakeTerrain.h"

#include "MakeTerrainDoc.h"
#include "MakeTerrainView.h"
#include "OpenglView.h"

#include "TerrainType.h"
#include "math.h"
#include "ObjetTroisD.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CXSTRETCH		15

extern CMakeTerrainApp theApp;
extern CMakeTerrainView * p2dView;
extern COpenglView * pOpenGlView;
extern int Dessin;
extern int Manip;
extern BOOL bRender;
extern int CoefHauteur;
extern int CoefZoom;
extern int CoefDep;
extern int CoefRotate;
int DessinIdTexture = -1;
int DessinIndexTexture = -1;
int DetailIdTexture = -1;
int DetailIndexTexture = -1;



int DrawTerrain	= DRAW_TERRAIN_HAUTEUR;
int PinceauType = PINCEAU_SQUARE;

extern int icam;
extern int jcam;
extern BOOL bPivotCam;
extern BOOL bDrawTerrainOnMouse;


/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainView

IMPLEMENT_DYNCREATE(CMakeTerrainView, CScrollView)

BEGIN_MESSAGE_MAP(CMakeTerrainView, CScrollView)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CMakeTerrainView)
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEWHEEL()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_RESET, OnReset)
	ON_COMMAND(ID_CONFIG_TERRAIN, OnConfigTerrain)
	ON_COMMAND(ID_RENDER, OnRender)
	ON_UPDATE_COMMAND_UI(ID_RENDER, OnUpdateRender)
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Standard printing commands
//	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
//	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
//	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainView construction/destruction

CMakeTerrainView::CMakeTerrainView()
{
	// TODO: add construction code here
	Scale = 1;
	bShift = FALSE;
	brushCote = 1;

	BrushPt.x = -100;
	BrushPt.y = -100;

	Rayon = 15;


}

CMakeTerrainView::~CMakeTerrainView()
{
}

BOOL CMakeTerrainView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainView drawing

void CMakeTerrainView::OnDraw(CDC* pDC)
{

	switch (DrawTerrain)
	{
		case DRAW_TERRAIN_HAUTEUR:DrawTerrainHauteur (pDC);
			break;
		case DRAW_TERRAIN_TEXTURE:DrawTerrainTexture (pDC);
			break;
	}

	DrawBrush (BrushPt);

}


// Dessiner le terrain en hauteur
void CMakeTerrainView :: DrawTerrainHauteur (CDC* pDC)
{
	DrawLandscape (pDC);
	//	pDC->Draw3dRect (0,0,dist,dist,RGB (220,220,220),RGB (140,140,140));
}




void CMakeTerrainView ::DrawMultiPoint (int indx,int indy,int np)
{
	POINTASC_TERRE * pt;
	int i,j;
	int indxdest,irayon;
	int indydest,jrayon;
	int NbPoint;
	CMakeTerrainDoc* pDoc;
	pDoc = GetDocument();	
	
	NbPoint = pDoc->GetTotalPoint ();
	if (indx >= NbPoint || indy >= NbPoint) return;
	

	indxdest = indx + np;
	indydest = indy + np;

	if (indxdest >= NbPoint) indxdest = NbPoint-1;
	if (indydest >= NbPoint) indydest = NbPoint-1;

	irayon = indx + np / 2;
	jrayon = indy + np / 2;
	if (irayon >= NbPoint) irayon = NbPoint-1;
	if (jrayon >= NbPoint) jrayon = NbPoint-1;

	for (i = indx; i <= indxdest; i++)
	for (j = indy; j <= indydest; j++)
	{
		pt = pDoc->GetPoint (i,j);
		// Pour le pinceau rond
		if (!PinceauCercle (irayon,jrayon,i,j)) continue;
		pDoc->SetPointY (i,j,pDoc->Hauteur);
	}
}



// Si le pinceau en cercle est slectionn on vrifie si un point
// est dans le rayon du cercle.
BOOL CMakeTerrainView :: PinceauCercle (int indx,int indy,int i,int j)
{
	if (PinceauType == PINCEAU_SQUARE) return TRUE;
	CMakeTerrainDoc* pDoc;
	pDoc = GetDocument();	
	POINTASC_TERRE * ptc;
	POINTASC_TERRE * ptd;

	ptc = pDoc->GetPoint (indx,indy);
	ptd = pDoc->GetPoint (i,j);


	
	float dist;
	float distx;
	float distz;
	distx = ptd->x - ptc->x;
	distz = ptd->z - ptc->z;

	dist = sqrt (distx*distx + distz*distz);
	if (dist > brushCote * pDoc->Largeur / 2) return FALSE;
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainView printing

BOOL CMakeTerrainView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMakeTerrainView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMakeTerrainView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainView diagnostics

#ifdef _DEBUG
void CMakeTerrainView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMakeTerrainView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMakeTerrainDoc* CMakeTerrainView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMakeTerrainDoc)));
	return (CMakeTerrainDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainView message handlers

void CMakeTerrainView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CMakeTerrainDoc* pDoc = GetDocument();
	int posx;
	int i,j;

	
	posx = pDoc->GetTotalPoint () * Scale;


	if (point.x >= 0 && point.x < posx && point.y >= 0 && point.y < posx)
	{
		if (bPivotCam == FALSE && bDrawTerrainOnMouse)
		{
			i = point.x / Scale;
			j = point.y / Scale;
			pDoc->SetMousePointeur (i,j);

			icam = i;
			jcam = j;
		}
	
	}


	// TODO: Add your message handler code here and/or call default
	if (nFlags & MK_LBUTTON)
	{
	if (point.x >= 0 && point.x < posx && point.y >= 0 && point.y < posx)
	{

			DrawBrush (BrushPt);

			switch (Dessin)
			{
				case DESSIN_PINCEAU:
				GetpointByBrush (point.x,point.y,i,j);
				pDoc->SetCurPoint (i,j);
				if (brushCote == 1) 
					pDoc->SetPointY (i,j,pDoc->Hauteur);
				else
					DrawMultiPoint (i,j,brushCote);
				break;

				case DESSIN_ARRONDISSEMENT:
				case DESSIN_COLLINE:
				case DESSIN_COLLINE_CREUX:
				i = point.x / Scale;
				j = point.y / Scale;
				pDoc->SetCurPoint (i,j);
				if (Dessin == DESSIN_ARRONDISSEMENT) DrawArrondissement (i,j,brushCote);
				else DrawColline (i,j,brushCote);
				break;


				case DESSIN_TEXTURE:
				GetpointByBrush (point.x,point.y,i,j);
				pDoc->SetIdTexture (i,j,brushCote,DetailIdTexture,DetailIndexTexture,FALSE);
				DrawMouseFacetteTexture (i,j);
				break;

				case DESSIN_APPLATIR:
				GetpointByBrush (point.x,point.y,i,j);
				DrawApplatir (i,j,brushCote);
				break;



			}

			// Mise  jour du bitmap de mapping
			pDoc->UpdateBitmap2D ();
			
			// Dessiner le bitmap de mapping seulement 
			// si on est dans le mode DRAW_TERRAIN_HAUTEUR
			switch (DrawTerrain)
			{
				case DRAW_TERRAIN_HAUTEUR:
				DrawLandscape (NULL,FALSE);
				break;
			}

			DrawBrush (point);
	}
	}
	else
	{
		DrawBrush (BrushPt);
		DrawBrush (point);
	}
	
	BrushPt = point;
	
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CMakeTerrainView :: GetpointByBrush (int x,int y,int &i,int &j)
{
	i = x / Scale;
	j = y / Scale;
	i -= brushCote / 2;
	j -= brushCote / 2;
	if (i < 0) i = 0;
	if (j < 0) j = 0;
}

BOOL CMakeTerrainView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO: Add your message handler code here and/or call default
	
//	if (Manip == MANIP_LARGEUR)
	if (Dessin == DESSIN_LARGEUR)
	{
		CMakeTerrainDoc* pDoc = GetDocument();
		if (zDelta < 0) pDoc->Largeur -= 100;
		if (zDelta > 0) pDoc->Largeur += 100;
		if (pDoc->Largeur < 50) pDoc->Largeur = 50;
		pDoc->Reset (FALSE);
		return CScrollView::OnMouseWheel(nFlags, zDelta, pt);
	}


	if (bShift)
	{
		CMakeTerrainDoc* pDoc = GetDocument();
		if (zDelta < 0) pDoc->Hauteur-= CoefHauteur;
		if (zDelta > 0) pDoc->Hauteur+= CoefHauteur;
		CWnd * parent;
		CString str;
		str.Format ("Hauteur = %d",pDoc->Hauteur);
		parent = AfxGetMainWnd ();
		parent->SetWindowText (str);

		return CScrollView::OnMouseWheel(nFlags, zDelta, pt);
	}


	if (zDelta < 0) 
	{
		Scale --;
		if (Scale < 1) Scale = 1;
	}

	if (zDelta > 0) Scale ++;
//	ReshapeScrolling ();

	Invalidate ();
	return CScrollView::OnMouseWheel(nFlags, zDelta, pt);
}

void CMakeTerrainView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	RECT rc;
	GetClientRect (&rc);
	switch (nChar)
	{
		case VK_SHIFT:bShift = TRUE;break;
		case VK_ADD:
			DrawBrush (BrushPt);
			brushCote ++;
			DrawBrush (BrushPt);
			break;
		case VK_SUBTRACT:
			DrawBrush (BrushPt);
			brushCote --;
			DrawBrush (BrushPt);
			if (brushCote < 1) brushCote = 1;
			break;
		case 'M':	bDrawTerrainOnMouse = (bDrawTerrainOnMouse == TRUE) ? FALSE : TRUE;break;
	}
	
	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMakeTerrainView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	switch (nChar)
	{
		case VK_SHIFT:bShift = FALSE;break;
	}
	
	CScrollView::OnKeyUp(nChar, nRepCnt, nFlags);
}


void CMakeTerrainView :: DrawBrush (CPoint pt)
{
	CDC * pDC;
	pDC = GetDC ();
	if (!pDC) return;

	switch (PinceauType)
	{
	
	case PINCEAU_SQUARE:
		pDC->PatBlt (
		pt.x-(brushCote/2*Scale),
		pt.y-(brushCote/2*Scale),
		brushCote*Scale,
		brushCote*Scale,PATINVERT);
		break;

	case PINCEAU_CIRCLE:
		pDC->SetROP2 (R2_NOT);
		pDC->Ellipse (pt.x-(brushCote/2*Scale),pt.y-(brushCote/2*Scale),
			pt.x+brushCote*Scale/2,pt.y+brushCote*Scale/2);
		break;
	}



	ReleaseDC (pDC);
}

void CMakeTerrainView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CMakeTerrainDoc* pDoc;
	pDoc = GetDocument();
	
	if (DrawTerrain != DRAW_TERRAIN_TEXTURE)
		Invalidate (FALSE);
	CScrollView::OnLButtonUp(nFlags, point);
}

void CMakeTerrainView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	OnMouseMove(nFlags,point);

	CScrollView::OnLButtonDown(nFlags, point);
}




void CMakeTerrainView::OnReset() 
{
	// TODO: Add your command handler code here
	CMakeTerrainDoc* pDoc;
	pDoc = GetDocument();
	pDoc->Reset ();
	pDoc->NormalFacette ();
	Invalidate ();
	
}

#include "resource.h"
void CMakeTerrainView::OnContextMenu(CWnd*, CPoint point)
{

	// CG: This block was added by the Pop-up Menu component
	{
		if (point.x == -1 && point.y == -1){
			//keystroke invocation
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_OPENGL_VIEW));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}

void CMakeTerrainView::OnConfigTerrain() 
{
	CMakeTerrainDoc* pDoc;
	pDoc = GetDocument();
	if (pDoc) 
	{
		pDoc->ConfigTerrain ();
		if (pOpenGlView) pOpenGlView->SetAllShipOnLandscape ();
	}
}



// Dessine un arrondissement
void CMakeTerrainView::DrawColline (int indx,int indy,int rayon)
{
	CMakeTerrainDoc* pDoc;
	int NbPoint;
	int i,j;
	int ideb,ifin;
	int jdeb,jfin;
	GLfloat dist;
	GLfloat distx,distz;
	GLfloat dist3D;
	POINTASC_TERRE * pt;
	POINTASC_TERRE * ptcentre;
	int largeur;

	GLfloat UnitAngle;
	GLfloat Angle;
	GLfloat NouvelleHauteur;
	

	pDoc = GetDocument();
	NbPoint = pDoc->GetTotalPoint ();
	largeur = pDoc->GetLargeur ();
	ptcentre = pDoc->GetPoint (indx,indy);

	dist3D = rayon * largeur;

	// Calculer l'unit d'angle
	UnitAngle = 90 / dist3D;
	

	ideb = indx - rayon;
	ifin = indx + rayon;

	if (ideb < 0) ideb = 0;
	if (ifin >= NbPoint) ifin = NbPoint-1;

	jdeb = indy - rayon;
	jfin = indy + rayon;

	if (jdeb < 0) jdeb = 0;
	if (jfin >= NbPoint) jfin = NbPoint-1;

	for (i = ideb; i <= ifin; i++)
	{
		for (j = jdeb; j <= jfin; j++)
		{
			
			pt = pDoc->GetPoint (i,j);
			distx = abs (pt->x - ptcentre->x);
			distz = abs (pt->z - ptcentre->z);

			dist = sqrt (distx*distx + distz*distz);
			if (dist > dist3D) continue;


			Angle = (dist3D - dist) * UnitAngle;
			
			
			switch (Dessin)
			{
			case DESSIN_COLLINE:
			NouvelleHauteur = 2 * pDoc->Hauteur * sin (Angle / 180);
				if (pt->y < NouvelleHauteur) pt->y = NouvelleHauteur;
				break;
			case DESSIN_COLLINE_CREUX:
			NouvelleHauteur = pDoc->Hauteur + (-2 * pDoc->Hauteur * sin (Angle / 180));
				if (pt->y > NouvelleHauteur) pt->y = NouvelleHauteur;
				break;
			}

			pDoc->ModifPoint (i,j);
			pDoc->SetPointColor (i,j,pt->y);

		}
	}
}


// Dessine un arrondissement
void CMakeTerrainView::DrawArrondissement (int indx,int indy,int rayon)
{
	CMakeTerrainDoc* pDoc;
	int NbPoint;
	int i,j;
	int ideb,ifin;
	int jdeb,jfin;
	GLfloat dist;
	GLfloat distx,distz,disty;
	GLfloat dist3D;
	POINTASC_TERRE * pt;
	POINTASC_TERRE * ptcentre;
	GLfloat dy;


	pDoc = GetDocument();
	NbPoint = pDoc->GetTotalPoint ();
	int largeur;
	largeur = pDoc->GetLargeur ();

	ptcentre = pDoc->GetPoint (indx,indy);

	dist3D = rayon * largeur;

	ideb = indx - rayon;
	ifin = indx + rayon;
	if (ideb < 0) ideb = 0;
	if (ifin >= NbPoint) ifin = NbPoint-1;

	jdeb = indy - rayon;
	jfin = indy + rayon;
	if (jdeb < 0) jdeb = 0;
	if (jfin >= NbPoint) jfin = NbPoint-1;

	for (i = ideb; i <= ifin; i++)
	{
		for (j = jdeb; j <= jfin; j++)
		{
			
			pt = pDoc->GetPoint (i,j);
			distx = abs (pt->x - ptcentre->x);
			distz = abs (pt->z - ptcentre->z);
			disty = abs (pt->y - pDoc->Hauteur);

			dist = sqrt (distx*distx + distz*distz);
			if (dist > dist3D) continue;

			dy = sqrt (dist3D*dist3D - dist*dist);
			
			if (pt->y <  pDoc->Hauteur + dy) pt->y = pDoc->Hauteur + dy;

			pDoc->ModifPoint (i,j);
			pDoc->SetPointColor (i,j,pt->y);
		}
	}
}


void CMakeTerrainView::OnRender() 
{
	bRender = (bRender) ? FALSE : TRUE;

	if (bRender)
	{
		CMakeTerrainDoc* pDoc;
		pDoc = GetDocument();
		pDoc->Render ();
	}

}

void CMakeTerrainView::OnUpdateRender(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (bRender);
}






BOOL CMakeTerrainView::OnEraseBkgnd(CDC* pDC) 
{
	
	// TODO: Add your message handler code here and/or call default
	CBrush hbr (RGB (255,255,255));
	RECT rc;
	GetClientRect (&rc);
	pDC->FillRect (&rc,&hbr);
	// return CScrollView::OnEraseBkgnd(pDC);
	return TRUE;
}

int CMakeTerrainView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	p2dView = this;

	CDC * pDC;
	
	pDC = GetDC ();
	hdc = CreateCompatibleDC (pDC->m_hDC);
	ReleaseDC (pDC);

	
	return 0;
}



// Permet de dessiner toutes les textures de facettes
void CMakeTerrainView::DrawTerrainTexture (CDC* pDC)
{
	CMakeTerrainDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	int Case,iFacette;
	int i,j,npoint;

	npoint = pDoc->GetTotalPoint ();

	for (i = 0; i < npoint; i++)
	{
		for (j = 0; j < npoint; j++)
		{

			Case = (j * (npoint - 1)) + i;
			iFacette = (Case * 2)+1;
			if (iFacette%2) DrawFacetteTexture (pDC,i,j,iFacette);

		}
	}
}

// Dessine une texture quand la souris bouge
void CMakeTerrainView :: DrawMouseFacetteTexture (int ideb,int jdeb)
{
	CDC * pDC;
	CMakeTerrainDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	int Case,iFacette;
	int NbPoint = pDoc->GetTotalPoint ();

	int i,j;
	int ifin,jfin;
	int nFace;

	
	pDC = GetDC ();
	
	if (ideb < 0) ideb = 0;
	if (jdeb < 0) jdeb = 0;
	if (ideb >= NbPoint-1)	ideb = NbPoint - 2;
	if (jdeb >= NbPoint-1)	jdeb = NbPoint - 2;
	nFace = brushCote;
	if (nFace == -1) nFace = 0;


	ifin = ideb + brushCote;
	jfin = jdeb + brushCote;

	if (ifin < 0) ifin = 0;
	if (jfin < 0) jfin = 0;
	if (ifin >= NbPoint-1)	ifin = NbPoint - 2;
	if (jfin >= NbPoint-1)	jfin = NbPoint - 2;

	int irayon,jrayon;
	irayon = ideb + brushCote / 2;
	jrayon = jdeb + brushCote / 2;
	if (irayon >= NbPoint-1)	irayon = NbPoint - 2;
	if (jrayon >= NbPoint-1)	jrayon = NbPoint - 2;



	for (i = ideb; i <= ifin; i++)
	{
		for (j = jdeb; j <= jfin; j++)
		{

			if (!PinceauCercle (irayon,jrayon,i,j)) continue;
			
			Case = (j * (NbPoint - 1)) + i;
			iFacette = (Case * 2)+1;
	
			if (iFacette%2) DrawFacetteTexture (pDC,i,j,iFacette);
		}
	}

	int dist;
	dist = NbPoint * Scale;
//	pDC->Draw3dRect (0,0,dist,dist,RGB (220,220,220),RGB (140,140,140));

	ReleaseDC (pDC);
}

// Dessine la texture lie  la facette
void CMakeTerrainView::DrawFacetteTexture (CDC* pDC,int i,int j,int no)
{
	HBITMAP hBmp,hold;
	FACETTE_TERRE * pFace;
	CMakeTerrainDoc* pDoc = GetDocument();
	pFace = pDoc->GetFacette (no);
	if (!pFace || pFace->IdTextureDetail == -1) return;
	
	hBmp = NULL;
	hBmp = theApp.GetTextureHandle (pFace->IndexTextureDetail);
	if (!hBmp) return;


	BITMAP bm;
	GetObject (hBmp,sizeof (BITMAP),&bm);


	hold = (HBITMAP) SelectObject (hdc,hBmp);
	StretchBlt(pDC->m_hDC,i*Scale,j*Scale,Scale,Scale,hdc,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
	SelectObject (hdc,hold);
}


void CMakeTerrainView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	
	ReshapeScrolling ();
}

void CMakeTerrainView :: ReshapeScrolling ()
{
	int NbPoint;
	SIZE sizeTotal;
	CMakeTerrainDoc* pDoc = GetDocument();
	
	// TODO: Add your specialized code here and/or call the base class
	NbPoint = pDoc->GetTotalPoint ();
	// TODO: Add your specialized code here and/or call the base class
	NbPoint = pDoc->GetTotalPoint ();
	sizeTotal.cx = Scale * NbPoint;
	sizeTotal.cy = Scale * NbPoint;
	SetScrollSizes (MM_TEXT,sizeTotal,sizeTotal,sizeTotal);
}




void CMakeTerrainView :: DrawApplatir (int ideb,int jdeb,int npoint)
{
	int i,j;
	int ifin,jfin;
	int NbPoint;
	POINTASC_TERRE	* pt;
	CMakeTerrainDoc * pDoc = GetDocument();
	NbPoint = pDoc->GetTotalPoint ();

	ifin = ideb + npoint;
	jfin = jdeb + npoint;

	if (ifin < 0) ifin = 0;
	if (jfin < 0) jfin = 0;
	if (ifin >= NbPoint)	ifin = NbPoint - 1;
	if (jfin >= NbPoint)	jfin = NbPoint - 1;


	if (ideb < 0) ideb = 0;
	if (jdeb < 0) jdeb = 0;
	if (ideb >= NbPoint)	ideb = NbPoint - 1;
	if (jdeb >= NbPoint)	jdeb = NbPoint - 1;


	for (i = ideb; i <= ifin; i++)
	{
		for (j = jdeb; j <= jfin; j++)
		{
			
			pt = pDoc->GetPoint (i,j);
			if (pt->y > pDoc->Hauteur) 
			{
				pDoc->SetPointY (i,j,pDoc->Hauteur);
				pDoc->ModifPoint (i,j);
			}
		}
	}
}


void CMakeTerrainView::DrawLandscape (CDC * pDC,BOOL bpDCIsCreated)
{
	CMakeTerrainDoc* pDoc = GetDocument();
	int SizeStretch;
	BITMAP bm;
	CDC hdc;
	ASSERT_VALID(pDoc);

	if (!bpDCIsCreated) pDC = GetDC ();
	
	// TODO: add draw code for native data here
	hdc.CreateCompatibleDC (pDC);
	hdc.SelectObject (pDoc->BmpLand);
	
	pDoc->BmpLand.GetBitmap (&bm);
	SizeStretch = bm.bmWidth * Scale;
	pDC->StretchBlt (0,0,SizeStretch,SizeStretch,&hdc,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);

	if (!bpDCIsCreated) ReleaseDC (pDC);
}








